package ch.hepia.structure;

import java.lang.Math;
import java.util.Random;
import java.util.List;

public class BinaryHeap{
    public int[] heap;
    private int maxCap;
    private int nbOfElem;

    public BinaryHeap(int size){
        maxCap = size;
        heap = new int[size];
        nbOfElem = 0;
    }

    public int parent(int i){ 
        return (i-1)/2; 
    } 
    public int left(int i){ 
        return (2*i + 1); 
    } 
  
    public int right(int i){ 
        return (2*i + 2); 
    } 
    private void swap(int index1, int index2) {
        int element = heap[index1];
        heap[index1] = heap[index2];
        heap[index2] = element;
    }

    public void push(int val){
        if (nbOfElem == maxCap) { 
            System.out.println("Plus de place !");
            return; 
        } 
    
        heap[nbOfElem] = val;
        nbOfElem++;
  
        int index = nbOfElem - 1;

        while (index > 0 && heap[parent(index)] < heap[index]) {
            swap(parent(index), index);
            index = parent(index);
        }
    }

    public int pop(){
        int element = heap[0];

        heap[0] = heap[nbOfElem - 1];
        nbOfElem--;
        
        int index = 0;

        while (left(index) < nbOfElem) {
            int smallestChildIndex = left(index);

            if (right(index) < nbOfElem && heap[right(index)] < heap[left(index)]) {
                smallestChildIndex = right(index);
            }

            if (heap[index] < heap[smallestChildIndex]) {
                swap(index, smallestChildIndex);
            } else {
                break;
            }
            index = smallestChildIndex;
        }

        return element; 
    }

    public int peek(){
        return heap[0];
    }

    public void addAll(List<Integer> lst){
        for(int x : lst){
            this.push(x);
        }
    }

    public boolean isEmpty(){
        return (nbOfElem == 0);
    }

    public boolean exists(int k){
        for(int x : heap){
            if(x == k){
                return true;
            }
        }
        return false;
    }

    public int size(){
        return nbOfElem;
    }

    public int depth(){
        int prof = 1; // on compte la racine
        int size = nbOfElem;
        do {
            size = size/2;
            prof = prof + 1;
        }
        while (size > 1);
        return prof;
    }

    public void populate(int nbValues){
        Random random = new Random();
        for (int i = 0; i < nbValues; i++) {
            int randomVal = random.nextInt(100);
            this.push(randomVal);
        }
    }

    public void printHeap(){
        for (int x : this.heap) {
            System.out.print(x + " ");
        }
    }

    public static void main(String[] args){

    }

}